module HAL.Doc.EntityTree where

import GHC.Generics

import Data.Aeson ((.:), (.:?), (.!=), Value(..), ToJSON, FromJSON(..), encode)
import Data.Default
import Data.Text (pack, Text)

import Servant.API (ToHttpApiData(..))


data EntityTree = EntityTree
  {
    _docid :: Int,
    _label_s :: Maybe Text,
    _parentEntityTreeid_i :: [Text]
  } deriving (Generic)

instance Default EntityTree where
  def = EntityTree def def def

instance FromJSON EntityTree where
  parseJSON (Object o) = EntityTree <$>
    (o .: "docid")
    <*> (o .:? "label_s")
    <*> (o .:? "parentEntityTreeid_i" .!= [])

instance ToHttpApiData EntityTree where
  toUrlPiece _ = "docid,label_s,parentEntityTreeid_i"

instance Show EntityTree where
  show (EntityTree id label _) = show label
    <> "(" <> show id <> ")"

